
/*************** Practica 02. Especificacion clase Conjunto********************
 *
 *  Nombre de Fichero: conjunto.h
 *
 *  Proposito: Declaracion de la interfaz de la clase conjunto
 *
 *  Condiciones de Final Anormal y Mensajes de Error y Advertencia
 *
 *  --> No hay final anormal
  *  --> No hay mensajes de error y advertencia
 *
 *  Historia de Desarrollo:
 *  Fecha     Autor           Id Cambio  Version  Descripcion del cambio
 *  --------  --------------  ---------  -------  ----------------------
 *  15-03-02  Ricardo Ferris          0      1.0
 *  15-03-04  Jesus Albert            1      1.1   Adaptacion a cambios en
 *                                                 enunciado
 *
 *****************************************************************************/

const int MAX = 500;

class Conjunto
{
    public:
        //Tipo de datos de los elementos del conjunto
        typedef int Elemento;

        // Inicia el conjunto a vaco
        void IniciarConjunto (void);

        // Aade un 'Elemento' al conjunto
        // Si la estructura para guardar la informacin es esttica
        // y el elemento si que cabe, devolver el exito de la funcin.
        bool AnadirElemento (Conjunto::Elemento);

        // Elimina el 'Elemento' del conjunto
        // Si el 'Elemento' no pertenece al conjunto simplemente no hace nada
        void BorrarElemento (Conjunto::Elemento);

        // Comprueba si el conjunto es o no vaco
        bool EsConjuntoVacio (void);

        // Comprueba si el 'Elemento' esta contenido en el conjunto
        bool Contiene (Conjunto::Elemento);

        // Muestra todos los elementos contenidos en el conjunto
        void MostrarConjunto (void);

    private:
        typedef Conjunto::Elemento Vector [MAX + 1];

        //numero de elementos del conjunto
        int n;
        //array que almacena los elementos del conjunto
        Vector v;
};

