
/*************** Practica 02. Criba de Eratostenes ********************
 *
 *  Nombre de Fichero: criba.cpp
 *
 *  Proposito: En este programa se implementa el mtodo de la criba
 *             de Eratostenes para el calculo de los numeros primos
 *             comprendidos entre 1 y n
 *
 *  Condiciones de Final Anormal y Mensajes de Error y Advertencia
 *
 *  --> No hay final anormal
 *  --> No hay mensajes de error
 *
 *  Historia de Desarrollo:
 *  Fecha     Autor           Id Cambio  Version  Descripcion del cambio
 *  --------  --------------  ---------  -------  ----------------------
 *  15-03-02  Ricardo Ferris          0      1.0
 *  15-03-04  Jesus Albert            1      1.1   Reestructuracion
 *****************************************************************************/

#include <stdlib.h>
#include <iostream.h>
#include "00conjunto.h"

/*****************************************************************************
 * PROGRAMA PRINCIPAL
 *****************************************************************************/
int main (void)
{
   Conjunto::Elemento i, j;
   Conjunto::Elemento n;
   Conjunto conjInicial, conjPrimos;
   bool error;

   cout << "Calculo de los numeros primos entre 1 y n." << endl;
   cout << "Introducir el valor de n: ";
   cin >> n;

   conjInicial.IniciarConjunto ();
   conjPrimos.IniciarConjunto ();

   // 1 es primo por definicion
   conjPrimos.AnadirElemento (1);

   /*
    * introducir los valores entre 2 y n en un conjunto
    * si los valores no caben en el conjunto solo se procesaran
    * los que quepan
    */
   i = 2;
   while ( (i <= n) && conjInicial.AnadirElemento (i) )
      i++;

   /*
    * Procesar los valores del conjunto
    * El primer valor es primo + eliminar sus multiplos
    */
    for (i = 2; i<=n; i++)
    {
      if (conjInicial.Contiene (i) )
      {
         conjPrimos.AnadirElemento (i);
         // eliminar multiplos
         j = i;
         while ( j <= n )
         {
            conjInicial.BorrarElemento (j);
            j += i;
         }
      }
   }

   // Mostrar resultados
   cout << "Conjunto de numeros primos: " << endl;
   conjPrimos.MostrarConjunto ();

   system ("PAUSE");
   return 0;
}

