
/*************** Practica 02. Programa de prueba *****************************
 *
 *  Nombre de Fichero: 00prueba.cpp
 *
 *  Proposito: este programa sirve para comprobar el correcto funcionamiento
 *             de la clase 'conjunto' implementada por los alumnos
 *
 *  Condiciones de Final Anormal y Mensajes de Error y Advertencia
 *
 *  --> No hay final anormal
 *  --> No hay mensajes de error
 *
 *  Historia de Desarrollo:
 *  Fecha     Autor           Id Cambio  Version  Descripcion del cambio
 *  --------  --------------  ---------  -------  ----------------------
 *  15-03-04  Ricardo Ferris          0      1.0
 *****************************************************************************/

#include <iostream>
using namespace std;
#include <stdlib.h>

/*
 * Incluir aqui el fichero de cabecera adecuado para cada pareja
 */
#include "00conjunto.h"

const Conjunto::Elemento INI = 1;
const Conjunto::Elemento FIN = 12;

/*****************************************************************************
 * PROGRAMA PRINCIPAL
 *****************************************************************************/
int main(void)
{
    Conjunto::Elemento i;
    Conjunto cjto;

    /*
     * Iniciamos el conjunto a vacio
     */
    cjto.IniciarConjunto ();

    cout << "Conjunto iniciado a vacio:\n";
    cjto.MostrarConjunto ();

    /*
     * Probamos el correcto funcionamiento del metodo 'EsConjuntoVacio'
     */
    cout << "\nComprobamos si el conjunto es o no vacio:\n";
    if (cjto.EsConjuntoVacio () )
        cout << "El conjunto es vacio.\n";
    else
        cout << "El conjunto NO es vacio.\n";

    /*
     * Probamos el correcto funcionamiento del metodo 'AnadirElemento'
     * anadiendo al conjunto un cierto numero de elementos pares
     */
    cout << "\nPonemos los valores pares desde el valor " << INI;
    cout << " hasta el " << FIN << endl;
    for (i = INI; i <= FIN / 2; i++)
        cjto.AnadirElemento (i * 2);

    cjto.MostrarConjunto ();

    /*
     * Comprobamos el correcto funcionamiento del metodo 'Contiene'
     * mirando si unos determinados elementos estan o no en el conjunto
     */
    cout << "\nComprobamos si estn o no en el conjunto ciertos elementos:\n";
    for (i = INI; i <= FIN; i++)
        if (cjto.Contiene (i) )
            cout << "El conjunto contiene el elemento: " << i << endl;
        else
            cout << "El conjunto NO contiene el elemento: " << i << endl;

    /*
     * Comprobamos el correcto funcionamiento del metodo 'EliminarElemento'
     * eliminando del conjunto los elementos multiplos de 3
     */
    cout << "\nEliminamos del conjunto los elementos multiplos de 3:\n";
    for (i = 3; i <= FIN; i += 3)
        cjto.BorrarElemento (i);

    cjto.MostrarConjunto ();

    /*
     * Volvemos a comprobar el correcto funcionamiento del metodo
     * 'EsConjuntoVacio' pero ahora con un conjunto no vacio
     */
    cout << "\nComprobamos si el conjunto es o no vacio:\n";
    if (cjto.EsConjuntoVacio () )
        cout << "El conjunto es vacio.\n";
    else
        cout << "El conjunto NO es vacio.\n";

    system ("PAUSE");
    return 0;
}
